
#ifndef WIDGET_H
#define WIDGET_H

#include "..\ObjectPool\ObjectPool.h"
#include <WTypes.h>

namespace ghost{

	struct WidgetImpl;

	class Widget{
		WidgetImpl* pImpl_;

	private:
		explicit Widget(HWND hWnd);
		explicit Widget(Widget* pParent);
		~Widget();
		Widget(const Widget&);
		Widget& operator =(const Widget&);

		// öܹWidget
		friend class ObjectPool<Widget>;
#pragma warning(push)
#pragma warning(disable:4396)
		friend void std::_Destroy(Widget _FARQ *);
#pragma warning(pop)

	public:
		static Widget* Create(HWND hWnd); // ؼ
		static Widget* Create(Widget* pParent); // ؼ
		void Destroy();

	public:
		HWND GetContainerWindow() const;
		Widget* GetRoot() const;
		bool IsRoot() const;
	};

} // namespace ghost

#endif // WIDGET_H