
#ifndef WIDGET_DRIVER_H
#define WIDGET_DRIVER_H

#include <WTypes.h>

namespace ghost{

	class Widget;

	namespace widget{

		class DriverImpl_;

		class Driver_{
			friend class Widget;

			DriverImpl_* pImpl_;

		private:
			explicit Driver_(HWND hWnd);
			~Driver_();
			Driver_(const Driver_&);
			Driver_& operator =(const Driver_&);

		private:
			void SetRootWidget(Widget* pRootWidget);
			HWND GetContainerWindow() const;
			Widget* GetRootWidget() const;
		};

	} // namespace widget

} // namespace ghost

#endif // WIDGET_DRIVER_H