
#ifndef WIDGET_MESSAGE_FILTER_H
#define WIDGET_MESSAGE_FILTER_H

#include <WTypes.h>

namespace ghost{

	class Widget;

	namespace widget{

		class MessageFilter{
			MessageFilter(){}

		public:
			struct Param{
				HWND hWnd;
				UINT message;
				WPARAM wParam;
				LPARAM lParam;
				WNDPROC originalProc;
			};

			static LRESULT Filter(const Param& param, Widget* pRootWidget);
		};

	} // namespace widget

} // namespace ghost

#endif // WIDGET_MESSAGE_FILTER_H